/*
 * Package: auto-pilot
 * Erez Zadok <ezk@cs.sunysb.edu>
 * Charles P. Wright <cwright@cs.sunysb.edu>
 * Copyright (c) 2001-2006 Stony Brook University
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#ifdef _SEM_SEMUN_UNDEFINED
union semun
{
	int val;                           // value for SETVAL
	struct semid_ds *buf;              // buffer for IPC_STAT & IPC_SET
	unsigned short int *array;         // array for GETALL & SETALL
	struct seminfo *__buf;             // buffer for IPC_INFO
};
#endif

int main(int argc, char *argv[]) {
	int sem_id;
	int key;
	union semun sem_union;

	if (argc != 3) {
		fprintf(stderr, "%s key value\n", argv[0]);
		exit(1);
	}
	key = atoi(argv[1]);
	sem_union.val = atoi(argv[2]);

	if ((sem_id = semget((key_t)key, 1, 0666 | IPC_CREAT | IPC_EXCL)) == -1) {
		perror("semget");
		exit(1);
	}

	if (semctl(sem_id, 0, SETVAL, sem_union) == -1) {
		perror("semctl");
		exit(1);
	}

	return 0;
}
